
#import <appkit/appkit.h>

@interface RulePanel:View {

	id		ascru;
	id		toascru;
	id		hxRule;
	id		pSliders;
	id		pWindows;
	id		ruleBox;
	id		ruleNumber;
	id		totlRef;
	id		sIncr;
	id		tiDat;
	id		wrule;

/* Rule Panel  - - - - - - - - - - - - - - - - - - - - - - - - - */

	id		compBox;
	id		compWindow;
	id		infoPanel;
	id		mainWindow;
	id		menuCopy;
	id		menuPrint;
	id		nowBox;
	id		nowSpesh;
	id		speshPanel;
	id		probView;

	id		s00,s01,s02,s10,s11,s12,s20,s21,s22;/****/

	id		gfWindow;

	id		stRuleNumber;
	id		stRuleBox;

/* ----- symmetry class  Window -----------------------------------------*/

	id		symBox;
	id		symImages;
	id		symMinimum;
	id		symRuleBox;

	id		toBox;
	id		toFullNumber;
	id		toRuleNumber;
	id		toRuleBox;
        id              titime;

	id		pRu;

        id              twoRules;
        id              specBigBox;
        id              specLilBox;
        id              equivRuleBox;
        id		subsetRuleBox;
        id              arithmRuleBox;

	id		designPrm;
	id		designRef;
	id		zeZeZe;
        id              browser;
        id              changeLine;

/*-------- a line of REC code ------------*/

 	id		RECLine;
	id		RECPanel;
	id		RECValue;

/*-------- composite rule -------------*/

	id		composRuleNumb;
	id		composRuleBox;
	id		compTable;

}

- freeAllRules:sender;
- ranRules:sender;
- ranPRules:sender;
- relatedRule:sender;
- readTRule:sender;
- readWRule:sender;
- protectGenRule:sender;
- readHxRule:sender;
- setAllRules:sender;
- setDemo:sender;
- setRule:sender; 
- showProbability:sender;
- symRule:sender;
- zeroRules:sender;
 
- randomLine:sender;
- sCellLine:sender;
- uniformLine:sender;

- Demorule:sender;
- defineWruleyob:(int) i;
- arithmCombs:sender;
- initTwoRules:sender;
- enterGF2Rule:sender; 
- setMCoeff:sender;
- setSCoeff:sender;
- setVCoeff:sender;

- showSymClass:sender;

- enterSemiRule:sender;
- setSemiState:sender;

- enterTotalisticRule:sender;
- setTotRule:sender;
- setTotRules:sender;

- xenophilic:sender;
- xenophobic:sender;

- clearDesign:sender;
- copyToDesign:sender;
- deZign:sender;
- enterDesign:sender;

/*----------- special rules --------------*/

- loadLowerPanel:thisRuleBox;  
- loadSpecialRule:sender;

/*---------- a line of REC code -----------*/

- runRECLine:sender;
- useRECLine:sender; 

/*---------- composite rule ------------*/

- composRule:sender;
- compxRule:sender;
- comprRule:sender;
- makeCompTable:sender;

- idenRule:sender;

@end 

/* end RulePanel.h */ 
