# include "rec.h"
# include <ctype.h>

# define IPPD	((sizeof(double) + sizeof(Inst) - 1)/sizeof(Inst))

union iad {
    Inst i[IPPD];
    double d;
};

r_cnum(func)		/* Compile a d.p. number into the program array */
Inst func;
{
    int c, period=0;
    char *s;
    union iad u;


    r_code(func);
    s = r_pbufp - 1;
    if (r_lastchar == '.')
	period = 1;
    while (isdigit(c = r_nxtchar()) || (c == '.' && !period))
	if (c == '.')
	    period = 1;
    if (c == 'e' || c == 'E') {
	if ((c = r_nxtchar()) != '+' && c != '-')
	    r_ungetch();
	while (isdigit(r_nxtchar()))
	    ;
    }
    r_ungetch();
    if (sscanf(s, "%f", &u.d) != 1)
	u.d = 0.;
    for (c = 0; c < IPPD; c++)
	r_code(u.i[c]);
}

r_cmin(func)		/* compilation of '-' */
Inst func;
{
    int c;
    int r_dnum();

    c = r_nxtchar();	/* look ahead one character */
    r_ungetch();
    if (c == '.' || isdigit(c))
	r_cnum(r_dnum);		/* compile a number */
    else
	r_code(func);		/* compile a subtraction */
}

double r_fnum()
{
    int c;
    union iad u;

    for (c = 0; c < IPPD; c++)
	u.i[c] = *r_pc++;
    return u.d;
}
