
/* 
 * PairView.h -- Interface file for the PairView class 
 *
 * You may freely copy, distribute, and reuse the code in this example. 
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its itness for any particular use, or even that it has any use at all. 
 *
 */

#import <appkit/appkit.h>

@interface PairView:View {

	id		ordPair;
	id		treeShow;
	id		linkAge;
	id		moveWhich;
	id		nodeNumber;
	id		ruleNumber;

	id		prTriv1;
	id		prTriv2;

	id		menuCopy;
	id		menuPrint;

	id		pairWindow;
	id		thePairView;
	id		timeDate;
	
	id		delegate;
	id		crossCursor;
}

- copyPairView:sender;
- drawPair:sender;
- loadPair:sender;
- printPair:sender;
- redrawPair:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end PairView.h */
