
/* 
 * SusetView.h -- Interface file for the SusetView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has any use at all.
 *
 */

#import <appkit/appkit.h>

@interface SubsetView:View {

	id		treeShow;
	id		linkAge;
	id		moveWhich;
	id		nodeNumber;
	id		ruleNumber;

	id		suTriv1;
	id		suTriv2;

	id		theSubsetView;
	id		subsetWindow;
	id		timeDate;
	
	id		delegate;
	id		crossCursor;

	id		menuCopy;
	id		menuPrint;
}

- copySubsetView:sender;
- drawSubset:sender;
- loadSubset:sender;
- prepareSubset:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end SubsetView.h */
