
/* keybd.h             				  */
/* A compilation of non-printing keyboard symbols */
/* Harold V. McIntosh, 30 January 1992		  */

# define Kf1    '\273'  /* f1 key */
# define Kf2    '\274'  /* f2 key */
# define Kf3    '\275'  /* f3 key */
# define Kf4    '\276'  /* f4 key */

# define Kf5    '\277'  /* f5 key */
# define Kf6    '\300'  /* f6 key */
# define Kf7    '\301'  /* f7 key */
# define Kf8    '\302'  /* f8 key */

# define Kf9    '\303'  /* f8 key */
# define Kf10   '\304'  /* f8 key */

# define KF1    '\324'  /* F1 key */
# define KF2    '\325'  /* F2 key */
# define KF3    '\326'  /* F3 key */
# define KF4    '\327'  /* F4 key */

# define KF5    '\330'  /* F5 key */
# define KF6    '\331'  /* F6 key */
# define KF7    '\332'  /* F7 key */
# define KF8    '\333'  /* F8 key */

# define KF9    '\334'  /* f8 key */
# define KF10   '\335'  /* f8 key */

# define INS	'\322'	/* INSERT */
# define DEL	'\323'	/* DELETE */
# define PPU	'\307'  /* PAR UP */
# define PPD	'\317'	/* PAR DO */
# define PGU	'\311'	/* PAG UP */
# define PGD	'\321'	/* PAG DO */
# define KPU	'\367'  /* ^PAR UP */
# define KPD	'\365'	/* ^PAR DO */
# define KGU	'\204'	/* ^PAG UP */
# define KGD	'\366'	/* ^PAG DO */
# define ENT	'\015'  /* ENTER=CR  */
# define BAK	'\010'	/* BACKSPACE */
# define TAB	'\011'	/* TAB */


# define MOL	'\313'	/*  larrow - mouse left	    */
# define MOR	'\315'	/*  rarrow - mouse right    */
# define MOU	'\310'	/*  uarrow - mouse up 	    */
# define MOD	'\320'	/*  darrow - mouse down     */
# define MOA	'\363'	/* ^la mouse - left button  */
# define MOB	'\364'	/* ^ra mouse - right button */
# define MOX	 '\33'	/* esc mouse - both buttons */

/* end keybd.h */
