/* nxardn21.h						*/
/* program for lcau21 option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/
/* adapted for NeXTSTEP 5 May 1994			*/

/*  Copyright (C) 1990	*/
/*  Copyright (C) 1994	*/
/*  Harold V. McIntosh	*/

void edard();
void allmo();
void tencu(thrparn *cumat, parneih *amat, parneih *bmat);
void tensq(twoparn *tmat, parneih *amat, parneih *bmat);
void cheq(double k[4][2], int z[KK][KK]);
void clard();
void rvers(parneih *amat, parneih *bmat);
void histo(parneih *amat, parneih *bmat);
int  issqr(int brul[KK][KK][KK]);
void rever();
int  runiq(int brul[KK][KK][KK], int rrul[KK][KK][KK]);
void squruls();
void squrt();
int  suniq(int brul[KK][KK][KK]);
int  tuniq(int brul[KK][KK][KK]);
void pmat(parneih *z, int i, int j);
void ppmat(twoparn *z, int i, int j);
void qqmat(twoparn *z, int i, int j);
unsigned int tsum(parneih *z);
unsigned int ttsum(twoparn *z);
unsigned int nzel(parneih *z);
unsigned int nnzel(twoparn *z);
void cymat(parneih *z, parneih *x);
void ccymat(twoparn *z, twoparn *x);
void mmat(parneih *z, parneih *x, parneih *y);
void mmmat(twoparn *z, twoparn *x, twoparn *y);
void mmmmat(thrparn *z, thrparn *x, thrparn *y);
void djmat(parneih *z, int l);
void unmat(twoparn *z);
void unimat(thrparn *z);
void zmat(parneih *z);
void zzmat(twoparn *z);
void zzzmat(thrparn *z);
void auua(double *ave, double *var, double *ex, double *wy, double *cve, double *vec, twoparn *mat);
void avva(double *ave, double *var, double *vec, twoparn *mat);
void rowsum(int x[KK][KK], parneih *z);
void colsum(int x[KK][KK], parneih *z);

/* end nxardn21.h */