# include "rec.h"
# include <stdio.h>
# include <ctype.h>

extern int r_lastchar;

r_cnum(func)
Inst func;
{
    char s[42];
    int i, c, period=0;
    short sval;
    long lval;
    double dval;
    Symbol *sym;

    r_code(func);
    s[0] = r_lastchar;
    if (r_lastchar == '.')
	period = 1;
    for (i = 1; i<100 && (isdigit(c = r_nxtchar()) 
			|| (c == '.' && !period)); i++)
	if ((s[i] = c) == '.')
	    period = 1;
    if (i == 100)
	r_errterm("Too many digits in number");
    if (c == 'e' || c == 'E') {
	period = 1;
	s[i++] = c;
	if ((c = r_nxtchar()) == '+' || c == '-') {
	    if (c == '-')
		s[i++] = c;
	    c = r_nxtchar();
	}
	r_ungetch(c);
	for ( ; i<100 && isdigit(c = r_nxtchar()); i++)
	    s[i] = c;
	if (i >= 100)
	    r_errterm("Too many digits in number");
    }
    s[i] = '\0';
    r_ungetch(c);
    if (period) {
	sscanf(s, "%lf", &dval);
	if ((sym = r_lookup((char *) &dval, REAL)) == (Symbol *) 0)
	    r_code((Inst) r_install((char *) &dval, REAL * sizeof(ushort)));
	else
	    r_code((Inst) sym);
    }
    else if (r_lastchar == '0' && i > 1 || r_lastchar == '-' && s[1] == '0') {
	sscanf(s, "%ld", &lval);
	if ((sym = r_lookup((char *) &lval, LONG)) == (Symbol *) 0)
	    r_code((Inst) r_install((char *) &lval, LONG * sizeof(ushort)));
	else
	    r_code((Inst) sym);
    }
    else {
	sscanf(s, "%hd", &sval);
	if ((sym = r_lookup((char *) &sval, WORD)) == (Symbol *) 0)
	    r_code((Inst) r_install((char *) &sval, WORD * sizeof(ushort)));
	else
	    r_code((Inst) sym);
    }
}

r_cmin(func)		/* compilation of '-' */
Inst func;
{
    int c;
    int r_ld();

    c = r_nxtchar();	/* look ahead one character */
    r_ungetch(c);
    if (c == '.' || isdigit(c))
	r_cnum(r_ld);		/* compile a number */
    else
	r_code(func);		/* compile a subtraction */
}
