# include "rec.h"

extern Symbol *r_symlist;		/* tabla de simbolos: lista encadenada */

Symbol *r_lookup(s,len)		/* busca a s en la tabla */
char *s;
int len;
{
    Symbol *sp;

    for (sp = r_symlist; sp != (Symbol *) 0; sp = sp->next)
	if (len == sp->len && cmpnch(sp->name, s, len) == 0)
	    return sp;
    return 0;		/* no estuvo */
}

static cmpnch(s,t,n)
register char *s, *t;
register int n;
{
    while (n-- && *s++ == *t++)
	;
    if (n < 0)
	return 0;
    else
	return (*--s - *--t);
}

Symbol *r_install(s,len)	/* instala a s de longitud len */
char *s;
int len;
{
    Symbol *sp;
    char *r_malloc();
    register char *dest;

    sp = (Symbol *) r_malloc(sizeof(Symbol));
    sp->len = (short) len;
    dest = sp->name = r_malloc(len);
    while (len--)
	*dest++ = *s++;
    sp->next = r_symlist;		/* a la cabeza de la lista */
    r_symlist = sp;
    return sp;
}
